Unit GraphApp;
Interface
Uses GraphObj;
   Const      NPoints = 100; {⢮ 祪}
   Type
    TGraphApp = Object
                 Points: Array [1..NPoints] Of TPoint; {ᨢ 祪}
                 Line: TLine; {}
                 Rect: TRect; {אַ㣮쭨}
                 Circ: TCircle; {㦭}
                 ActiveObj: Integer; {⨢ ꥪ}
                 Procedure Init;
                 Procedure Run;
                 Destructor Done;
                 Procedure ShowAll;
                 Procedure MoveActiveObj (dX,dY:Integer);
                End;
Implementation
Uses Graph,CRT;

Procedure TGraphApp.Init;
{樠 ᪨ ० ࠡ ࠭.  }
{⮡ࠦ NPoints ஢ ꥪ TPoint,  ⠪   }
{ ꥪ⮢ TLine,TCircle, TRect.                }
Var
   D,R,Err,k: Integer;
Begin
   D:=Detect;
   InitGraph(D,R,'C:\BP\BGI');
   Err:=GraphResult;
   If Err<>0 Then
   Begin
        GraphErrorMsg(Err);
        Halt;
   End;
   For k:=1 To NPoints Do
       Points[k].Init(Random(GetMaxX),Random(GetMaxY),Random(15)+1);
   Line.Init(GetMaxX div 3,GetMaxY div 3,2*GetMaxX div 3,
                  2*GetMaxY div 3,LightRed);
   Circ.Init(GetMaxX div 2,GetMaxY div 2,GetMaxY div 5,White);
   Rect.Init(2*GetMaxX div 5,2*GetMaxY div 5,3*GetMaxX div 5,
                              3*GetMaxY div 5,Yellow);
   ShowAll; { ᪨ ꥪ}
   ActiveObj:=1; { ६頥 אַ㣮쭨}
End;

Procedure TGraphApp.Run; {롮  ६饭 ꥪ  ࠭}
Var
    Stop: Boolean; {ਧ  ESC}
Const
     D=5; { ᬥ饭 䨣}
Begin
     Stop:=False;
     Repeat {  }
           Case ReadKey Of {⠥  ⮩ }
           #27: Stop:=True; {  ESC}
            #9: Begin {  TAB}
                     Inc (ActiveObj);
                     If ActiveObj>3 Then ActiveObj:=3;
                End;
            #0: Case ReadKey Of
                  #71: MoveActiveObj(-D,-D); {  }
                  #72: MoveActiveObj(0,-D); {}
                  #73: MoveActiveObj( D,-D); {ࠢ  }
                  #75: MoveActiveObj(-D,0); {}
                  #77: MoveActiveObj( D,0); {ࠢ}
                  #79: MoveActiveObj(-D,D); {  }
                  #80: MoveActiveObj(0, D); {}
                  #81: MoveActiveObj( D, D); {ࠢ  }
                End;
           End;
           ShowAll;
     Until Stop;
End;

Destructor TGraphApp.Done;
Begin
     CloseGraph;
End;

Procedure TGraphApp.ShowAll; {  ꥪ⮢}
Var
   k:Integer;
Begin
     For k:=1 To NPoints Do Points[k].Show;
     Line.Show;
     Rect.Show;
     Circ.Show;
End;

Procedure TGraphApp.MoveActiveObj {६饭 ⨢ ꥪ};
Begin
     Case ActiveObj Of
          1: Rect.MoveTo(dX,dY);
          2: Circ.MoveTo(dX,dY);
          3: Line.MoveTo(dX,dY);
     End;
End;

End.
